<html lang="en" class="+full-height"><head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

        <!-- Kwaeri CSS -->
        <link rel="stylesheet" href="https://mmod.gitlab.io/kwaeri-user-experience/dist/css/kux_md--comprehensive.min.css">

        <title>@kwaeri/xfmr</title>
    </head>
    <body class="+inverse-colors mdc-typography">


        <!-- The Side Menu - MDC Drawer Based. We add a bit of functionality to provide a feature rich Side Menu. -->
        <aside data-menu="side-menu" data-menu-type="hybrid-permanent-modal" data-menu-initialized="false" class="mdc-drawer side-menu +mimic-appbar +inverse ">
            <div class="mdc-drawer__toolbar-spacer"></div>
            <header class="mdc-drawer__header">
                <div class="mdc-drawer__header-content">
                  <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=YUW4CWCAABCU2" target="_blank" title="Donate to Massivley Modified" class="image-link +horizontally-centered"><div class="icon-donations"></div></a>
                </div>
            </header>
            <div class="mdc-drawer__content">

                <!-- The Side Menu nav element -->
                <nav id="icon-with-text-demo" class="mdc-list">
                    <!-- Side Menu Section Title -->
                    <span class="side-menu_section-title">Introduction</span>
                    <!-- Side Menu Section Nav -->
                    <ul class="side-menu_nav side-menu_menu-section">

                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="what-is-knkc" data-scroll-to-target="what-is-knkc">@kwaeri/configuration?</button>
                        </li>

                        <!-- Side Menu Section Menu Item -->
                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="getting-started" data-expandable="getting-started" data-expandable-type="side-menu" aria-expanded="false">Getting Started</button>
                            <!-- Side Menu Section Menu Item Sub-Nav (otional) -->
                            <div class="side-menu_submenu-wrap">
                                <!-- Side Menu Sub Nav -->
                                <ul class="submenu_nav submenu_menu-section" data-expand="getting-started" data-expanded="false">
                                    <!-- And there we may place sub-nav_item for each fragment of the section -->
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="prerequisites" data-scroll-to-target="prerequisites">Prerequisites</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="installing-the-module" data-scroll-to-target="installing-the-module">Installing the Module</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="including-the-module" data-scroll-to-target="including-the-module">Including the Module</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="using-the-module" data-scroll-to-target="using-the-module">Using the Module</a></li>
                                </ul>
                            </div>
                        </li>
                    </ul>

                    <!-- Side Menu Section Title -->
                    <span class="side-menu_section-title">Components</span>
                    <!-- Side Menu Section Nav -->
                    <ul class="side-menu_nav side-menu_menu-section">
                        <!-- Side Menu Section Menu Item -->
                        <li class="side-menu_menu-item">
                            <!-- The button can link directly to content -->
                            <button class="side-menu_submenu-toggle mdc-button" data-menu-item="API " data-expandable="api" data-expandable-type="side-menu" aria-expanded="false">API</button>
                            <!-- Side Menu Section Menu Item Sub-Nav (otional) -->
                            <div class="side-menu_submenu-wrap">
                                <!-- Side Menu Sub Nav -->
                                <ul class="submenu_nav submenu_menu-section" data-expand="api" data-expanded="false">
                                    <!-- And there we may place sub-nav_item for each fragment of the section -->
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="get" data-scroll-to-target="get">get()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="read" data-scroll-to-target="read">read()</a></li>
                                    <li class=""><a class="submenu_menu-item mdc-button" data-submenu-item="write" data-scroll-to-target="write">write()</a></li>
                                </ul>
                            </div>
                        </li>
                    </ul>


                    <div class="side-menu-select-item-divider mdc-list-divider" role="separator"></div>

                    <a class="mdc-list-item" href="mailto:support@mmod.co">
                        <i class="material-icons mdc-list-item__graphic" title="Email Support" aria-hidden="true">email</i>Email Support
                    </a>
                </nav>
            </div>
        </aside> <!-- End the Side Menu-->

        <div class="mdc-drawer-scrim"></div>

        <!-- The topAppBar - we only add a couple things to give additional functionality from what Google gives us. -->
        <header class="mdc-top-app-bar mdc-top-app-bar--fixed" data-animation="rebound-scroll" data-rebounded="false" data-menu="top-menu">
            <div class="mdc-top-app-bar__row">
                <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-start">
                    <a data-menu="navigation-drawer" data-drawer="permanent" class="material-icons mdc-top-app-bar__navigation-icon hidden">menu</a>
                    <div class="navbar_brand icon-logo-badge-small-dev"></div>
                    <span class="mdc-top-app-bar__title">kwaeri.io</span>
                </section>
                <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-end" role="toolbar">
                    <div class="mdc-menu-surface--anchor">
                        <a class="material-icons mdc-top-app-bar__action-item" data-dropdown="filedownload" title="Download @kwaeri/configuration" aria-label="Download" alt="Download">file_download</a>
                        <div class="mdc-menu mdc-menu-surface" tabindex="-1" data-menu="dropdown" data-for="filedownload">
                            <ul class="mdc-menu__items mdc-list" role="menu" aria-hidden="true">
                                <li class="mdc-list-item" role="menuitem" tabindex="0">
                                    <a href="https://gitlab.com/kwaeri/node-kit/configuration/-/archive/master/configuration-master.zip" class="drop-down_item" title="Download .zip" aria-label="Download .zip">Download a Zip</a>
                                </li>
                                <li class="mdc-list-item" role="menuitem" tabindex="0">
                                    <a href="https://gitlab.com/kwaeri/node-kit/configuration/-/archive/master/configuration-master.tar.gz" class="drop-down_item" title="Download .tar.gz" aria-label="Download .tar.gz">Download a Tarball</a>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <a href="/coverage" class="material-icons mdc-top-app-bar__action-item" title="Code Coverage" aria-label="Code Coverage" alt="Code Coverage">book</a>
                </section>
            </div>
        </header> <!-- End the topAppBar -->

        <!-- The Site/App main content -->
        <div id=client-display" data-feature="focus" class="container mdc-top-app-bar--fixed-adjust +flex-side-menu +flex-scrollspy">

            <div class="container-fluid +top">

                <section class="featured +read-easy">

                    <article class="featured_article">


                        <!---<div data-drag="test-handle" class="draggable">
                            <div data-handle="test-handle" class="draggable_handle">Draggable Window: Handle</div>
                            <div class="draggable_content">
                                <p>This is a draggable element.</p>
                            </div>

                        </div>-->


                        <div class="article_header">

                            <div class="article_header+wider">
                                <h1>kwaeri/xfmr</h1>
                                <p>The kwaeri/xfmr component of the kwaeri application platform.</p>
                            </div>

                            <div class="article_header+related">

                                <span class="content_related-list+title">Contents</span>
                                <ul class="content_related-list">
                                    <li>Related content I</li>
                                    <li>Related content II</li>
                                    <li>Related content III</li>
                                </ul>
                            </div>

                        </div>

                        <hr>

                        <div id="what-is-xfmr" class="article_header+sub">
                            <h6>kwaeri/xfmr reinvents the gulp-based bump-version component of the kwaeri platform&amp;s module build pipeline.</h6>

                            <p>kwaeri/xfmr provides an implementation for transforming version and copyright strings within source code, as well as specifically within the package.json file of Node.js modules,</p>
                        </div>

                        <hr>

                        <div class="article_body">

                            <!-- A section for Getting Started -->
                            <section id="getting-started" class="article_section"> <!-- Can have a max-width (controlled by media queries) set, but we already do that on featured + read-easy in this example  -->

                                <!-- Section Header -->
                                <h2 class="article_chapter-title">Getting Started</h2>
                                <!-- End of Section Header -->

                                <!-- Section Body -->
                                <div class="section_body"> <!-- Material.io's equivalent, article__copy, only has postiion relative set.. we can do this too! -->


                                    <!-- Section Body Fragment (there should be many ) -->
                                    <div id="prerequisites" class="fragment +collapsible" data-collapsible="prerequisites" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="prerequisites" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Preparing for Installation</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="prerequisites">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="prerequisites">

                                                <p>This section covers the prerequisites for making use of the kwaeri/xfmr component.</p>

                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="prerequisites">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
#### Preparing for use

To make use of the kwaeri/xfmr component,  you'll need to ensure you meet some prerequisites. The following technologies are required:

* Node.js (latest version)
    * NPM (typically bundled with later Node.js installs)

The above prerequisites ensure that you are able to install - and make use of - the kwaeri/xfmr component.

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->


                                    <!-- Anothe Section Body Fragment -->
                                    <div id="installing-the-module" class="fragment +collapsible" data-collapsible="installing-the-module" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="installing-the-module" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Installing the Module</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="installing-the-module">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="installing-the-module">
                                                <p>This section provides step-by-step instructions for installing kwaeri/xfmr.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="installing-the-module">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
#### Installation

To install kwaeri/configuration, please run the following commands from terminal/command-prompt:

<!-- Show a code snippet -->
<pre class="command-line language-bash" data-user="rik" data-host="kwaeri" data-filter-output="[out]">
    <code class="language-bash">
    [out] ...
    npm install --save-dev @kwaeri/xfmr
    </code>
</pre><!-- End of code snippet-->

That's it! You're set to make use of the kwaeri/xfmr component.

                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->

                                    </div> <!-- End of Fragment -->


                                    <!-- Yet Another Section Fragment-->
                                    <div id="including-the-module" class="fragment +collapsible" data-collapsible="including-the-module" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="including-the-module" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Including the Module</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="including-the-module">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="including-the-module">
                                                <p>This section provides instructions for how to include the kwaeri/xfmr component within an application.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="including-the-module">

                                                    <!-- A markdown block for providing content to this fragment -->
                                                    <div data-markdown="render" data-rendered="false">
To include kwaeri/xfmr in your application, add the following code to the source code you wish to make use of it in:

<!-- Show a code snippet -->
```javascript
import { Transformer } from "@kwaeri/xfmr";
```

That's it! You're set to make use of kwaeri/xfmr programatically.

                                                    </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->


                                    <!-- Yet Another Section Fragment-->
                                    <div id="using-the-module" class="fragment +collapsible" data-collapsible="using-the-module" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="using-the-module" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">Using the Module</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="using-the-module">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="using-the-module">
                                                <p>This section provides instructions for how to use kwaeri/xfmr.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="using-the-module">

                                                    <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
### Usage

The xfmr component is leveraged for transforming the version and copyright of source files (with specific support for the version string in `package.json` files) as part of a build and publish pipeline.

To leverage the xfmr component, you can use it either:

* As a ServiceProvider of kue
* Via CLI in terminal (or similar)
* Via npm scripts
* Programatically

#### As a ServiceProvider of kue

The *command* is ***`bump`*** and the *specification* is either ***`version`*** or ***`copyright`***.

```bash
kue bump version
```

or

```bash
kue bump copyright
```

When dealing with @kwaeri/xfmr as a ServiceProvider, there are some options you can leverage. To get a list of those options, install the ServiceProvider by adding it to the list of providres in the `cli.json` file in the root of your project, and run:

```bash
kue bump --help
```

Alternatively, you can view the list of flags and options [here](#options).

For specifying the target source, as well as providing configuration, see [here](#configuration).,

#### Via Terminal-CLI

When running the Xfmr from a global installation, or from within a Node project where it is installed locally, you can forego invoking with `node` and leverage the registered binary alias: `xfmr-cli`.

```bash
xfmr-cli --bump-version --source
```

Otherwise, The binary is ***`node`*** and the target path of the binary script (as opposed to `kue`, or `xfmr-cli`) :

```bash
node ./node_modules/@kwaeri/xfmr/dist/src/bin/cfmr-cli.mjs --bump-version --project
```

When you consider how kue binaries break user commands into *command* ⇨ *specification*, the arguments passed differ slightly from when leveraging @kwaeri/xfmr as a ServiceProvider of kue.

* To bump the version, use *`--bump-version`*
    * The target must also be specified:
    * To target source file versions for files other than the `package.json`, use *`--source`*
    * To target module/project version, specifically in `package.json`, use *`--project`*
    * *NOTE* *This only specifies which preconfigured globs and keys to use from the [configuration](#configuration).*
* To bump the copyright, use *`--bump-copyright`*

Thus, to bump source file versions with default settings:

```bash
node ./node_modules/@kwaeri/xfmr/dist/src/bin/xfmr-cli.mjs --bump-version --source
```

#### As a NPM Script

To use @kwaeri/xfmr as part of a NPM script, write a script that invokes the xfmr as if you were invoking it directly from the command line ([see above](#via-terminal-cli)):

```json
{
    "scripts": {
    "bump:version": "node ./dist/src/bin/xfmr-cli.mjs --bump-version --source",
    "bump:copyright": "node ./dist/src/bin/xfmr-cli.mjs --bump-copyright --source",
    }
}
```

Then, run the npm script:

```bash
npm run bump:version
```

## Options and Configuration

* Options refer to the flags and arguments that can be passed to a CLI invocation.
* Configuration refers to the options that can and/or must be set in a file named `.xfmrc`.

### Defaults

When running `kue bump version < --source | --project >` with no additional flags or arguments, it increments the patch component of the semver. The key used is ` * @version: `.

When running `kue bump copyright` with no additional flags or arguments, it expects to find a year range, and increments the *latest* copyright year component to the current year - if it is not already the current year. The key used is ` *  Copyright © `.


### Options

The options, per specification, are as follows:

#### Version Bump

| `version` Options   | Desc                                           | Values                     |
|---------------------|------------------------------------------------|----------------------------|
| --component         | Specify the semver component to increment      | major, minor               |
| --to-version        | Specify the specific version to set            | Any valid semver           |
| --project           | Denotes to bump version in `package.json`      | None, flag-type            |
| --source            | Denotes to bump version in source files        | None, flag-type            |

With regards to the `project` and `source` flags, they can be present in the same invocation.

#### Copyright Bump

| `copyright` Option | Desc                                           | Values                         |
|--------------------|------------------------------------------------|--------------------------------|
| --type             | Specify the type of copyright bump to perform  | range (default), each, current |

With regards to copyright's *`--type`* option, it can be one of the following types:

* `range` maintains a **2020 - 2022** type of display (start to latest), and would bump the ***end*** (i.e. `2022`) component.
* `each` adds the current year, if not already present, to the current comma separated list of copyright years (i.e. **2020, 2022** ).
* `current` updates the single copyright year to the current year if it is not already the current year.

### Options Explained

In the following examples we'll assume that you've decided to create a [npm script](#as-a-npm-script) as part of a build pipeline when preparing for a new release, but with the `--source` flag removed, so as to explain the options. You can normally just place these options within the npm script itself, but we'll be explaining them by passing them to the script - hence the presence of `--`, which separates arguments passed to `npm` from arguments passed to the script itself *(see [here](https://github.com/npm/npm/pull/5518) for more information about the presence of `--`)*.

#### By Component

To increment a component of the version string, run `npm run bump:version -- --<source|project> --component <type>`. This will also reset any subsequent components to 0.

#### To a Specific Version

To set the version string to a specific version, run `npm run bump:version -- --<source|project> --to-version <version>`.

#### Of Source Files

To bump the version in ordinary source files, flag `--source`.

#### Of Package.json

To bump the version specifically in `package.json`, flag `--project`.

To be continued...

### Configuration

To allow for specifying the configuration of @kwaeri/xfmr, the module expects a `.xfmrc` file at the root of your project. Some default fallbacks are implemented, but at this time the only way to specify the target is through this configuration (See [this](#configuration-required) for more information).

For clarification, here's the most minimal configuration required:

```jsonc
{
    "source": { // Denotes source file transform options
        "match": [ "**/*.js" ],
    },
    "module": { // Denotes module metadata file (package.json) transform options
        "match": [ "package.json" ],
    }
}
```

#### Breakdown

There are two major focuses of @kwaeri/xfmr;

* Normal source files
* The project or module metadata file

With regards to the transformations that @kwaeri/xfmr currently provides, only the `bump version` transformation targets both focuses. When we leverage @kwaeri/xfmr for copyright transform - this is not applied to the package or module metadata file.

The configuration contained should minimally specify the required source file glob patterns, and any optional glob ignore patterns. You may also optionally specify any glob option supported by the [glob](https://www.npmjs.com/package/glob#options) module, destination paths for build and test runs, and alternate keys for all supported transformations.

This is why there is a `key` object for the `source` configuration, but only a `key` string for the `module` configuration.

Here's an example *comprehensive* configuration:

```jsonc
{
    "source": { // Denotes source file transform options
        "match": [
            "**/*.mts",
            "**/*.cts",
            "**/*.ts",
            "**/*.mjs",
            "**/*.cjs",
            "**/*.js"
        ],
        "globOptions": {
            "base": "./",
            "ignore": [ // Ignore patterns can be placed within globOptions
                "node_modules{/,/**}",
                "build{/,/**}",
                "dist{/,/**}",
                "test{/,/**}"
            ]
        },
        "key": {  // Copyright can only be bumped in source files, so key specification is unique here.
            "version": " * @version ",
            "copyright": " *  Copyright © "
        },
        "destination": ".",         // These destinations are the defauls, if not provided.
        "testDestination": "tests"
    },
    "module": { // Denotes module metadata file (package.json) transform options
        "match": [
            "package.json"
        ],
        "globOptions": {
            "base": "./"
        },
        "key": "\"version\": \"",
        "destination": ".",       // These destinations are the defauls, if not provided.
        "testDestination": "tests"
    }
}
```

#### Configuration Required

Ideally, we'd like to support a default implementation for when there is no configuration by allowing for the passing of paths via STDIN.

For example, one could do so as follows:

```bash
kue bump version --files "file.ext, file2.ext" --source
```

This would also allow for globbing of input sources according to the available means of doing so on a per-system basis.

On Debian Linux, for example, one could do so as follows:

```bash
echo "'$(echo -n *.mts **/*.mts *.cts **/*cts | sed "s/ /','/g")'" | cat - | <invoke xfmr>
```

Which - at the time of this writing, and on the system used - translates to:

```bash
'index.mts','dist/index.d.mts','tests/index.mts','index.cts','dist/index.d.cts','src/xfmr.cts','tests/index.cts' | ...
```

The benefits to allowing the module to work this way should be immediately discernable. How to allow this type of functionality has also already been discerned -

Below is the list of blocking items:

* `kue` needs to support reading from STDIN and packing utf8 encoded data into `NodeKitOptions` so that `Steward` can hand it off to ServiceProviders when delegating fullfilment of user commands.
* `xfmr` needs to support taking from `NodeKitOptions` when used as a ServiceProvider,
* ~~`xfmr-cli` needs to support reading from STDIN directly when used as a CLI binary itself directly.~~ Done
* ~~In all cases, `process `must be manually `unref()`'d so as to ensure that all scripts finish after all work is done.~~ done

Due to an immediate need for the functionality of this module, @kwaeri/xfmr is being initially published without said support completed. It will be added at a later time.

As such, the configuration object is required to at least minimally specify the taget source to apply desired transformations to.
                                                    </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                </div> <!-- End of Section Body -->

                            </section> <!-- End of Section -->

                            <hr>

                            <!-- Another Section that moves on to Layout of an application using this Library -->
                            <section id="api" class="article_section">

                                <!-- Section Heading -->
                                <h2 class="article_chapter-title">API</h2>
                                <!-- End of Section Heading -->

                                <!-- Section Body -->
                                <div class="section_body">

                                    <!-- Section Body Fragment -->
                                    <div id="get" class="fragment +collapsible" data-collapsible="get" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="get" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.get()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="get">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="get">
                                                <p>This section provides instructions for making use of the .get() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="get">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
**Under construction...**
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="read" class="fragment +collapsible" data-collapsible="read" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="read" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.read()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="read">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="read">
                                                <p>This section provides instructions for making use of the .read() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="read">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
**Under construction...**
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                    <!-- Section Body Fragment -->
                                    <div id="write" class="fragment +collapsible" data-collapsible="write" data-collapsed="false" aria-expanded="true">

                                        <!-- Capsule (Fragment Header & Toolbar) -->
                                        <div class="collapsible_capsule">
                                            <!-- Collapsible button -->
                                            <button aria-label="Collapse Content" data-collapse="write" class="collapsible_toggle toggle-button"></button>

                                            <!-- Fragment Header -->
                                            <h3 class="fragment_heading">.write()</h3>
                                            <!-- End of Fragment Header -->

                                        </div>

                                        <!-- Fragment Body -->
                                        <div class="fragment_wrap" data-collapsible-wrap="write">

                                            <!-- Fragment Hint (shows on collapse) -->
                                            <div class="fragment_hint" data-collapsible-hint="write">
                                                <p>This section provides instructions for making use of the .write() method.</p>
                                            </div> <!-- End of Fragment Hint -->

                                            <!-- Fragment Content (hides on collapse) -->
                                            <div class="fragment_content" data-collapsible-content="write">

                                                <!-- A markdown block for providing content to this fragment -->
                                                <div data-markdown="render" data-rendered="false">
**Under construction...**
                                                </div> <!-- End of the markdown block -->

                                            </div> <!-- End of Fragment Content -->

                                        </div> <!-- End of Fragment Body -->
                                    </div> <!-- End of Fragment -->

                                </div> <!-- End of Section Body -->

                            </section> <!-- End of Section -->

                        </div> <!-- End of Article Body -->


                    </article> <!-- End of Article Container -->

                </section> <!-- End of Featured Container -->

            </div> <!-- End of Container-Fluid -->

        </div> <!-- End of Focus Container -->

        <!-- Optional right column, for related, scroll-spy, or advertisement perhaps?
        <nav class="short-nav +scrollspy">
            <div class="short-nav_toolbar-spacer"></div>
            <p>Testing 1,2,3</p>
        </nav>-->

        <button class="mdc-fab material-icons app-fab--absolute" aria-label="Scroll To Top" data-scroll-to-target="top">
            <span class="mdc-fab__icon">
                keyboard_arrow_up
            </span>
        </button>

        <!-- Add JavaScript inclusions just before the closing body tag -->
        <script src="assets/js/prism.js" async></script>
        <script src="https://mmod.gitlab.io/kwaeri-user-experience/dist/js/kwaeri-ux/kux-md-bundle.min.js" async></script>

    </body>
</html>